#include <stddef.h>

#include "qmi-enum-types.h"

static const struct GEnumValue qmi_nas_active_band_values[] = {
    {QMI_NAS_ACTIVE_BAND_BC_0, "QMI_NAS_ACTIVE_BAND_BC_0", "bc-0"},
    {QMI_NAS_ACTIVE_BAND_BC_1, "QMI_NAS_ACTIVE_BAND_BC_1", "bc-1"},
    {QMI_NAS_ACTIVE_BAND_BC_2, "QMI_NAS_ACTIVE_BAND_BC_2", "bc-2"},
    {QMI_NAS_ACTIVE_BAND_BC_3, "QMI_NAS_ACTIVE_BAND_BC_3", "bc-3"},
    {QMI_NAS_ACTIVE_BAND_BC_4, "QMI_NAS_ACTIVE_BAND_BC_4", "bc-4"},
    {QMI_NAS_ACTIVE_BAND_BC_5, "QMI_NAS_ACTIVE_BAND_BC_5", "bc-5"},
    {QMI_NAS_ACTIVE_BAND_BC_6, "QMI_NAS_ACTIVE_BAND_BC_6", "bc-6"},
    {QMI_NAS_ACTIVE_BAND_BC_7, "QMI_NAS_ACTIVE_BAND_BC_7", "bc-7"},
    {QMI_NAS_ACTIVE_BAND_BC_8, "QMI_NAS_ACTIVE_BAND_BC_8", "bc-8"},
    {QMI_NAS_ACTIVE_BAND_BC_9, "QMI_NAS_ACTIVE_BAND_BC_9", "bc-9"},
    {QMI_NAS_ACTIVE_BAND_BC_10, "QMI_NAS_ACTIVE_BAND_BC_10", "bc-10"},
    {QMI_NAS_ACTIVE_BAND_BC_11, "QMI_NAS_ACTIVE_BAND_BC_11", "bc-11"},
    {QMI_NAS_ACTIVE_BAND_BC_12, "QMI_NAS_ACTIVE_BAND_BC_12", "bc-12"},
    {QMI_NAS_ACTIVE_BAND_BC_13, "QMI_NAS_ACTIVE_BAND_BC_13", "bc-13"},
    {QMI_NAS_ACTIVE_BAND_BC_14, "QMI_NAS_ACTIVE_BAND_BC_14", "bc-14"},
    {QMI_NAS_ACTIVE_BAND_BC_15, "QMI_NAS_ACTIVE_BAND_BC_15", "bc-15"},
    {QMI_NAS_ACTIVE_BAND_BC_16, "QMI_NAS_ACTIVE_BAND_BC_16", "bc-16"},
    {QMI_NAS_ACTIVE_BAND_BC_17, "QMI_NAS_ACTIVE_BAND_BC_17", "bc-17"},
    {QMI_NAS_ACTIVE_BAND_BC_18, "QMI_NAS_ACTIVE_BAND_BC_18", "bc-18"},
    {QMI_NAS_ACTIVE_BAND_BC_19, "QMI_NAS_ACTIVE_BAND_BC_19", "bc-19"},
    {QMI_NAS_ACTIVE_BAND_GSM_450, "QMI_NAS_ACTIVE_BAND_GSM_450", "gsm-450"},
    {QMI_NAS_ACTIVE_BAND_GSM_480, "QMI_NAS_ACTIVE_BAND_GSM_480", "gsm-480"},
    {QMI_NAS_ACTIVE_BAND_GSM_750, "QMI_NAS_ACTIVE_BAND_GSM_750", "gsm-750"},
    {QMI_NAS_ACTIVE_BAND_GSM_850, "QMI_NAS_ACTIVE_BAND_GSM_850", "gsm-850"},
    {QMI_NAS_ACTIVE_BAND_GSM_900_EXTENDED, "QMI_NAS_ACTIVE_BAND_GSM_900_EXTENDED", "gsm-900-extended"},
    {QMI_NAS_ACTIVE_BAND_GSM_900_PRIMARY, "QMI_NAS_ACTIVE_BAND_GSM_900_PRIMARY", "gsm-900-primary"},
    {QMI_NAS_ACTIVE_BAND_GSM_900_RAILWAYS, "QMI_NAS_ACTIVE_BAND_GSM_900_RAILWAYS", "gsm-900-railways"},
    {QMI_NAS_ACTIVE_BAND_GSM_DCS_1800, "QMI_NAS_ACTIVE_BAND_GSM_DCS_1800", "gsm-dcs-1800"},
    {QMI_NAS_ACTIVE_BAND_GSM_PCS_1900, "QMI_NAS_ACTIVE_BAND_GSM_PCS_1900", "gsm-pcs-1900"},
    {QMI_NAS_ACTIVE_BAND_WCDMA_2100, "QMI_NAS_ACTIVE_BAND_WCDMA_2100", "wcdma-2100"},
    {QMI_NAS_ACTIVE_BAND_WCDMA_PCS_1900, "QMI_NAS_ACTIVE_BAND_WCDMA_PCS_1900", "wcdma-pcs-1900"},
    {QMI_NAS_ACTIVE_BAND_WCDMA_DCS_1800, "QMI_NAS_ACTIVE_BAND_WCDMA_DCS_1800", "wcdma-dcs-1800"},
    {QMI_NAS_ACTIVE_BAND_WCDMA_1700_US, "QMI_NAS_ACTIVE_BAND_WCDMA_1700_US", "wcdma-1700-us"},
    {QMI_NAS_ACTIVE_BAND_WCDMA_850, "QMI_NAS_ACTIVE_BAND_WCDMA_850", "wcdma-850"},
    {QMI_NAS_ACTIVE_BAND_WCDMA_800, "QMI_NAS_ACTIVE_BAND_WCDMA_800", "wcdma-800"},
    {QMI_NAS_ACTIVE_BAND_WCDMA_2600, "QMI_NAS_ACTIVE_BAND_WCDMA_2600", "wcdma-2600"},
    {QMI_NAS_ACTIVE_BAND_WCDMA_900, "QMI_NAS_ACTIVE_BAND_WCDMA_900", "wcdma-900"},
    {QMI_NAS_ACTIVE_BAND_WCDMA_1700_JAPAN, "QMI_NAS_ACTIVE_BAND_WCDMA_1700_JAPAN", "wcdma-1700-japan"},
    {QMI_NAS_ACTIVE_BAND_WCDMA_1500_JAPAN, "QMI_NAS_ACTIVE_BAND_WCDMA_1500_JAPAN", "wcdma-1500-japan"},
    {QMI_NAS_ACTIVE_BAND_WCDMA_850_JAPAN, "QMI_NAS_ACTIVE_BAND_WCDMA_850_JAPAN", "wcdma-850-japan"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_1, "QMI_NAS_ACTIVE_BAND_EUTRAN_1", "eutran-1"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_2, "QMI_NAS_ACTIVE_BAND_EUTRAN_2", "eutran-2"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_3, "QMI_NAS_ACTIVE_BAND_EUTRAN_3", "eutran-3"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_4, "QMI_NAS_ACTIVE_BAND_EUTRAN_4", "eutran-4"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_5, "QMI_NAS_ACTIVE_BAND_EUTRAN_5", "eutran-5"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_6, "QMI_NAS_ACTIVE_BAND_EUTRAN_6", "eutran-6"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_7, "QMI_NAS_ACTIVE_BAND_EUTRAN_7", "eutran-7"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_8, "QMI_NAS_ACTIVE_BAND_EUTRAN_8", "eutran-8"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_9, "QMI_NAS_ACTIVE_BAND_EUTRAN_9", "eutran-9"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_10, "QMI_NAS_ACTIVE_BAND_EUTRAN_10", "eutran-10"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_11, "QMI_NAS_ACTIVE_BAND_EUTRAN_11", "eutran-11"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_12, "QMI_NAS_ACTIVE_BAND_EUTRAN_12", "eutran-12"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_13, "QMI_NAS_ACTIVE_BAND_EUTRAN_13", "eutran-13"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_14, "QMI_NAS_ACTIVE_BAND_EUTRAN_14", "eutran-14"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_17, "QMI_NAS_ACTIVE_BAND_EUTRAN_17", "eutran-17"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_18, "QMI_NAS_ACTIVE_BAND_EUTRAN_18", "eutran-18"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_19, "QMI_NAS_ACTIVE_BAND_EUTRAN_19", "eutran-19"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_20, "QMI_NAS_ACTIVE_BAND_EUTRAN_20", "eutran-20"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_21, "QMI_NAS_ACTIVE_BAND_EUTRAN_21", "eutran-21"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_23, "QMI_NAS_ACTIVE_BAND_EUTRAN_23", "eutran-23"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_24, "QMI_NAS_ACTIVE_BAND_EUTRAN_24", "eutran-24"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_25, "QMI_NAS_ACTIVE_BAND_EUTRAN_25", "eutran-25"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_26, "QMI_NAS_ACTIVE_BAND_EUTRAN_26", "eutran-26"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_27, "QMI_NAS_ACTIVE_BAND_EUTRAN_27", "eutran-27"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_28, "QMI_NAS_ACTIVE_BAND_EUTRAN_28", "eutran-28"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_29, "QMI_NAS_ACTIVE_BAND_EUTRAN_29", "eutran-29"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_30, "QMI_NAS_ACTIVE_BAND_EUTRAN_30", "eutran-30"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_31, "QMI_NAS_ACTIVE_BAND_EUTRAN_31", "eutran-31"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_32, "QMI_NAS_ACTIVE_BAND_EUTRAN_32", "eutran-32"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_33, "QMI_NAS_ACTIVE_BAND_EUTRAN_33", "eutran-33"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_34, "QMI_NAS_ACTIVE_BAND_EUTRAN_34", "eutran-34"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_35, "QMI_NAS_ACTIVE_BAND_EUTRAN_35", "eutran-35"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_36, "QMI_NAS_ACTIVE_BAND_EUTRAN_36", "eutran-36"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_37, "QMI_NAS_ACTIVE_BAND_EUTRAN_37", "eutran-37"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_38, "QMI_NAS_ACTIVE_BAND_EUTRAN_38", "eutran-38"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_39, "QMI_NAS_ACTIVE_BAND_EUTRAN_39", "eutran-39"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_40, "QMI_NAS_ACTIVE_BAND_EUTRAN_40", "eutran-40"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_41, "QMI_NAS_ACTIVE_BAND_EUTRAN_41", "eutran-41"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_42, "QMI_NAS_ACTIVE_BAND_EUTRAN_42", "eutran-42"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_43, "QMI_NAS_ACTIVE_BAND_EUTRAN_43", "eutran-43"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_46, "QMI_NAS_ACTIVE_BAND_EUTRAN_46", "eutran-46"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_47, "QMI_NAS_ACTIVE_BAND_EUTRAN_47", "eutran-47"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_48, "QMI_NAS_ACTIVE_BAND_EUTRAN_48", "eutran-48"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_66, "QMI_NAS_ACTIVE_BAND_EUTRAN_66", "eutran-66"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_71, "QMI_NAS_ACTIVE_BAND_EUTRAN_71", "eutran-71"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_125, "QMI_NAS_ACTIVE_BAND_EUTRAN_125", "eutran-125"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_126, "QMI_NAS_ACTIVE_BAND_EUTRAN_126", "eutran-126"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_127, "QMI_NAS_ACTIVE_BAND_EUTRAN_127", "eutran-127"},
    {QMI_NAS_ACTIVE_BAND_EUTRAN_250, "QMI_NAS_ACTIVE_BAND_EUTRAN_250", "eutran-250"},
    {QMI_NAS_ACTIVE_BAND_TDSCDMA_A, "QMI_NAS_ACTIVE_BAND_TDSCDMA_A", "tdscdma-a"},
    {QMI_NAS_ACTIVE_BAND_TDSCDMA_B, "QMI_NAS_ACTIVE_BAND_TDSCDMA_B", "tdscdma-b"},
    {QMI_NAS_ACTIVE_BAND_TDSCDMA_C, "QMI_NAS_ACTIVE_BAND_TDSCDMA_C", "tdscdma-c"},
    {QMI_NAS_ACTIVE_BAND_TDSCDMA_D, "QMI_NAS_ACTIVE_BAND_TDSCDMA_D", "tdscdma-d"},
    {QMI_NAS_ACTIVE_BAND_TDSCDMA_E, "QMI_NAS_ACTIVE_BAND_TDSCDMA_E", "tdscdma-e"},
    {QMI_NAS_ACTIVE_BAND_TDSCDMA_F, "QMI_NAS_ACTIVE_BAND_TDSCDMA_F", "tdscdma-f"},
    {0, NULL, NULL}};

const char* qmi_nas_active_band_get_string(int val) {
  int i;

  for (i = 0; qmi_nas_active_band_values[i].value_nick; i++) {
    if (val == qmi_nas_active_band_values[i].value)
      return qmi_nas_active_band_values[i].value_nick;
  }

  return NULL;
}

static const struct GEnumValue qmi_nas_dl_bandwidth_values[] = {
    {QMI_NAS_DL_BANDWIDTH_1_4, "QMI_NAS_DL_BANDWIDTH_1_4", "1-4"},
    {QMI_NAS_DL_BANDWIDTH_3, "QMI_NAS_DL_BANDWIDTH_3", "3"},
    {QMI_NAS_DL_BANDWIDTH_5, "QMI_NAS_DL_BANDWIDTH_5", "5"},
    {QMI_NAS_DL_BANDWIDTH_10, "QMI_NAS_DL_BANDWIDTH_10", "10"},
    {QMI_NAS_DL_BANDWIDTH_15, "QMI_NAS_DL_BANDWIDTH_15", "15"},
    {QMI_NAS_DL_BANDWIDTH_20, "QMI_NAS_DL_BANDWIDTH_20", "20"},
    {QMI_NAS_DL_BANDWIDTH_INVALID, "QMI_NAS_DL_BANDWIDTH_INVALID", "invalid"},
    {QMI_NAS_DL_BANDWIDTH_UNKNOWN, "QMI_NAS_DL_BANDWIDTH_UNKNOWN", "unknown"},
    {0, NULL, NULL}};

const char* qmi_nas_dl_bandwidth_get_string(QmiNasDLBandwidth val) {
  int i;

  for (i = 0; qmi_nas_dl_bandwidth_values[i].value_nick; i++) {
    if (val == qmi_nas_dl_bandwidth_values[i].value)
      return qmi_nas_dl_bandwidth_values[i].value_nick;
  }

  return NULL;
}

static const struct GEnumValue qmi_nas_network_service_domain_values[] = {
    {QMI_NAS_NETWORK_SERVICE_DOMAIN_NONE, "QMI_NAS_NETWORK_SERVICE_DOMAIN_NONE", "none"},
    {QMI_NAS_NETWORK_SERVICE_DOMAIN_CS, "QMI_NAS_NETWORK_SERVICE_DOMAIN_CS", "cs"},
    {QMI_NAS_NETWORK_SERVICE_DOMAIN_PS, "QMI_NAS_NETWORK_SERVICE_DOMAIN_PS", "ps"},
    {QMI_NAS_NETWORK_SERVICE_DOMAIN_CS_PS, "QMI_NAS_NETWORK_SERVICE_DOMAIN_CS_PS", "cs-ps"},
    {QMI_NAS_NETWORK_SERVICE_DOMAIN_UNKNOWN, "QMI_NAS_NETWORK_SERVICE_DOMAIN_UNKNOWN", "unknown"},
    {0, NULL, NULL}};

const char* qmi_nas_network_service_domain_get_string(QmiNasNetworkServiceDomain val) {
  int i;

  for (i = 0; qmi_nas_network_service_domain_values[i].value_nick; i++) {
    if (val == qmi_nas_network_service_domain_values[i].value)
      return qmi_nas_network_service_domain_values[i].value_nick;
  }

  return NULL;
}

static const struct GEnumValue qmi_nas_modulation_values[] = {
    {QMI_NAS_MODULATION_BPSK, "QMI_NAS_MODULATION_BPSK", "BSPK"},
    {QMI_NAS_MODULATION_QPSK, "QMI_NAS_MODULATION_QPSK", "QSPK"},
    {QMI_NAS_MODULATION_16QAM, "QMI_NAS_MODULATION_16QAM", "16QAM"},
    {QMI_NAS_MODULATION_64QAM, "QMI_NAS_MODULATION_64QAM", "64QAM"},
    {QMI_NAS_MODULATION_256QAM, "QMI_NAS_MODULATION_256QAM", "256QAM"},
    {QMI_NAS_MODULATION_UNKNOWN, "QMI_NAS_MODULATION_UNKNOWN", "unknown"},
    {0, NULL, NULL}};

const char* qmi_nas_modulation_get_string(QmINasModulation val) {
  int i;

  for (i = 0; qmi_nas_modulation_values[i].value_nick; i++) {
    if (val == qmi_nas_modulation_values[i].value)
      return qmi_nas_modulation_values[i].value_nick;
  }

  return NULL;
}
